'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Creative = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _sortedListItem = require('../util/sorted-list-item');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Represents a creative.
 */
var Creative = exports.Creative = function (_SortedListItem) {
  _inherits(Creative, _SortedListItem);

  function Creative() {
    _classCallCheck(this, Creative);

    var _this = _possibleConstructorReturn(this, (Creative.__proto__ || Object.getPrototypeOf(Creative)).call(this));

    _this._id = null;
    _this._adID = null;
    _this._apiFramework = null;
    _this._universalAdId = null;
    _this._extensions = [];
    _this._linear = null;
    _this._companionAds = null;
    _this._nonLinearAds = null;
    return _this;
  }

  // Attribute(s).

  /**
   * The ID of this creative.
   *
   * @type {string}
   */


  _createClass(Creative, [{
    key: 'id',
    get: function get() {
      return this._id;
    },
    set: function set(value) {
      this._id = value;
    }

    /**
     * The ID of the {@link Ad} with which this creative is served.
     *
     * Required for VAST 2.0 and 3.0, optional for VAST 4.0.
     *
     * @type {string}
     */

  }, {
    key: 'adID',
    get: function get() {
      return this._adID;
    },
    set: function set(value) {
      this._adID = value;
    }

    /**
     * The string that identifies an API that is needed to execute this creative.
     *
     * @type {string}
     */

  }, {
    key: 'apiFramework',
    get: function get() {
      return this._apiFramework;
    },
    set: function set(value) {
      this._apiFramework = value;
    }

    // Children.

    /**
     * The unique creative identifier for this creative.
     *
     * @type {UniversalAdId}
     */

  }, {
    key: 'universalAdId',
    get: function get() {
      return this._universalAdId;
    },
    set: function set(value) {
      this._universalAdId = value;
    }

    /**
     * The creative extensions for this creative.
     *
     * @type {CreativeExtension[]}
     */

  }, {
    key: 'extensions',
    get: function get() {
      return this._extensions;
    }

    /**
     * The linear ad for this creative, if any.
     *
     * @type {Linear}
     */

  }, {
    key: 'linear',
    get: function get() {
      return this._linear;
    },
    set: function set(value) {
      this._linear = value;
    }

    /**
     * The companion ads for this creative, if any.
     *
     * @type {CompanionAds}
     */

  }, {
    key: 'companionAds',
    get: function get() {
      return this._companionAds;
    },
    set: function set(value) {
      this._companionAds = value;
    }

    /**
     * The non-linear ads for this creative, if any.
     *
     * @type {NonLinearAds}
     */

  }, {
    key: 'nonLinearAds',
    get: function get() {
      return this._nonLinearAds;
    },
    set: function set(value) {
      this._nonLinearAds = value;
    }
  }, {
    key: '$type',
    get: function get() {
      return 'Creative';
    }
  }]);

  return Creative;
}(_sortedListItem.SortedListItem);