'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Represents a list of verification resources for a vendor.
 */
var Verification = exports.Verification = function () {
  function Verification() {
    _classCallCheck(this, Verification);

    this._vendor = null;
    this._javaScriptResources = [];
    this._flashResources = [];
    this._viewableImpression = null;
  }

  // Attribute(s).

  /**
   * The home page URL for the verification service provider that supplies the
   * resource file.
   *
   * @type {string}
   */


  _createClass(Verification, [{
    key: 'vendor',
    get: function get() {
      return this._vendor;
    },
    set: function set(value) {
      this._vendor = value;
    }

    // Children.

    /**
     * The JavaScript resources for this verification vendor.
     *
     * @type {JavaScriptResource[]}
     */

  }, {
    key: 'javaScriptResources',
    get: function get() {
      return this._javaScriptResources;
    }

    /**
     * The Flash resources for this verification vendor.
     *
     * @type {FlashResource[]}
     */

  }, {
    key: 'flashResources',
    get: function get() {
      return this._flashResources;
    }

    /**
     * The viewable impression for this verification vendor.
     *
     * @type {ViewableImpression}
     */

  }, {
    key: 'viewableImpression',
    get: function get() {
      return this._viewableImpression;
    },
    set: function set(value) {
      this._viewableImpression = value;
    }
  }, {
    key: '$type',
    get: function get() {
      return 'Verification';
    }
  }]);

  return Verification;
}();