'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Represents a single companion inside {@link CompanionAds}.
 */
var Companion = exports.Companion = function () {
  function Companion() {
    _classCallCheck(this, Companion);

    this._id = null;
    this._width = null;
    this._height = null;
    this._assetWidth = null;
    this._assetHeight = null;
    this._expandedWidth = null;
    this._expandedHeight = null;
    this._apiFramework = null;
    this._adSlotID = null;
    this._pxratio = null;
    this._resource = null;
    this._adParameters = null;
    this._altText = null;
    this._clickThrough = null;
    this._clickTrackings = [];
    this._trackingEvents = null;
  }

  // Attribute(s).

  /**
   * The ID for this companion ad.
   *
   * @type {string}
   */


  _createClass(Companion, [{
    key: 'id',
    get: function get() {
      return this._id;
    },
    set: function set(value) {
      this._id = value;
    }

    /**
     * The width of this companion ad in pixels.
     *
     * @type {number}
     */

  }, {
    key: 'width',
    get: function get() {
      return this._width;
    },
    set: function set(value) {
      this._width = value;
    }

    /**
     * The height of this companion ad in pixels.
     *
     * @type {number}
     */

  }, {
    key: 'height',
    get: function get() {
      return this._height;
    },
    set: function set(value) {
      this._height = value;
    }

    /**
     * The width of this companion ad's asset in pixels.
     *
     * @type {number}
     */

  }, {
    key: 'assetWidth',
    get: function get() {
      return this._assetWidth;
    },
    set: function set(value) {
      this._assetWidth = value;
    }

    /**
     * The height of this companion ad's asset in pixels.
     *
     * @type {number}
     */

  }, {
    key: 'assetHeight',
    get: function get() {
      return this._assetHeight;
    },
    set: function set(value) {
      this._assetHeight = value;
    }

    /**
     * The expanded width of this companion ad in pixels.
     *
     * @type {number}
     */

  }, {
    key: 'expandedWidth',
    get: function get() {
      return this._expandedWidth;
    },
    set: function set(value) {
      this._expandedWidth = value;
    }

    /**
     * The expanded height of this companion ad in pixels.
     *
     * @type {number}
     */

  }, {
    key: 'expandedHeight',
    get: function get() {
      return this._expandedHeight;
    },
    set: function set(value) {
      this._expandedHeight = value;
    }

    /**
     * The API framework used by this companion ad.
     *
     * @type {string}
     */

  }, {
    key: 'apiFramework',
    get: function get() {
      return this._apiFramework;
    },
    set: function set(value) {
      this._apiFramework = value;
    }

    /**
     * The ad slot ID of this companion ad.
     *
     * @type {string}
     */

  }, {
    key: 'adSlotID',
    get: function get() {
      return this._adSlotID;
    },
    set: function set(value) {
      this._adSlotID = value;
    }

    /**
     * The pixel ratio for which the companion creative is intended.
     *
     * @type {string}
     */

  }, {
    key: 'pxratio',
    get: function get() {
      return this._pxratio;
    },
    set: function set(value) {
      this._pxratio = value;
    }

    // Children.

    /**
     * The resource associated with this companion ad.
     *
     * @type {StaticResource|IFrameResource|HTMLResource}
     */

  }, {
    key: 'resource',
    get: function get() {
      return this._resource;
    },
    set: function set(value) {
      this._resource = value;
    }

    /**
     * The ad parameters for this companion ad.
     *
     * @type {string}
     */

  }, {
    key: 'adParameters',
    get: function get() {
      return this._adParameters;
    },
    set: function set(value) {
      this._adParameters = value;
    }

    /**
     * The alt text of this companion ad.
     *
     * @type {string}
     */

  }, {
    key: 'altText',
    get: function get() {
      return this._altText;
    },
    set: function set(value) {
      this._altText = value;
    }

    /**
     * The click-through configuration.
     *
     * @type {Click}
     */

  }, {
    key: 'clickThrough',
    get: function get() {
      return this._clickThrough;
    },
    set: function set(value) {
      this._clickThrough = value;
    }

    /**
     * The click-tracking configurations.
     *
     * @type {Click[]}
     */

  }, {
    key: 'clickTrackings',
    get: function get() {
      return this._clickTrackings;
    }

    /**
     * The event-tracking configuration for this companion ad.
     *
     * @type {TrackingEvents}
     */

  }, {
    key: 'trackingEvents',
    get: function get() {
      return this._trackingEvents;
    },
    set: function set(value) {
      this._trackingEvents = value;
    }
  }, {
    key: '$type',
    get: function get() {
      return 'Companion';
    }
  }]);

  return Companion;
}();